

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>SmartRecruiting_BackEnd.api.routes &mdash; SmartRecruiting back v2 documentation</title>
  

  
  
  
  

  
  <script type="text/javascript" src="../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script type="text/javascript" src="../../../_static/jquery.js"></script>
        <script type="text/javascript" src="../../../_static/underscore.js"></script>
        <script type="text/javascript" src="../../../_static/doctools.js"></script>
        <script type="text/javascript" src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> SmartRecruiting back
          

          
          </a>

          
            
            
              <div class="version">
                v2
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../install.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../contributing.html">Contributing</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../documentation.html">Backend documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">SmartRecruiting back</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>SmartRecruiting_BackEnd.api.routes</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for SmartRecruiting_BackEnd.api.routes</h1><div class="highlight"><pre>
<span></span><span class="c1"># encoding: utf-8</span>
<span class="c1"># -*- coding: utf-8 -*-</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="sd">Routes and views for the flask application.</span>

<span class="sd">&quot;&quot;&quot;</span>
<span class="kn">from</span> <span class="nn">flask</span> <span class="k">import</span> <span class="n">jsonify</span><span class="p">,</span> <span class="n">json</span><span class="p">,</span> <span class="n">session</span><span class="p">,</span> <span class="n">g</span>
<span class="kn">from</span> <span class="nn">flask</span> <span class="k">import</span> <span class="n">abort</span><span class="p">,</span> <span class="n">request</span>
<span class="kn">from</span> <span class="nn">flask_cors</span> <span class="k">import</span> <span class="n">cross_origin</span>
<span class="kn">from</span> <span class="nn">functools</span> <span class="k">import</span> <span class="n">wraps</span>
<span class="kn">from</span> <span class="nn">bcrypt</span> <span class="k">import</span> <span class="n">gensalt</span><span class="p">,</span> <span class="n">hashpw</span>
<span class="kn">from</span> <span class="nn">jwt</span> <span class="k">import</span> <span class="n">encode</span><span class="p">,</span> <span class="n">decode</span><span class="p">,</span> <span class="n">DecodeError</span><span class="p">,</span> <span class="n">ExpiredSignature</span>
<span class="kn">from</span> <span class="nn">datetime</span> <span class="k">import</span> <span class="n">timedelta</span>
<span class="kn">from</span> <span class="nn">datetime</span> <span class="k">import</span> <span class="n">datetime</span>
<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd</span> <span class="k">import</span> <span class="n">app</span><span class="p">,</span> <span class="n">db_manager</span><span class="p">,</span> <span class="n">graph</span><span class="p">,</span> <span class="n">model</span>


<div class="viewcode-block" id="create_token"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.create_token">[docs]</a><span class="k">def</span> <span class="nf">create_token</span><span class="p">(</span><span class="n">user</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Create a token for a user with an expiration of 14 days</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">payload</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s1">&#39;sub&#39;</span><span class="p">:</span> <span class="n">user</span><span class="o">.</span><span class="n">email</span><span class="o">.</span><span class="n">decode</span><span class="p">(</span><span class="s1">&#39;utf-8&#39;</span><span class="p">),</span>
        <span class="s1">&#39;iat&#39;</span><span class="p">:</span> <span class="n">datetime</span><span class="o">.</span><span class="n">utcnow</span><span class="p">(),</span>
        <span class="s1">&#39;exp&#39;</span><span class="p">:</span> <span class="n">datetime</span><span class="o">.</span><span class="n">utcnow</span><span class="p">()</span> <span class="o">+</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">days</span><span class="o">=</span><span class="mi">14</span><span class="p">)</span>
    <span class="p">}</span>
    <span class="n">token</span> <span class="o">=</span> <span class="n">encode</span><span class="p">(</span><span class="n">payload</span><span class="p">,</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;TOKEN_SECRET&#39;</span><span class="p">])</span>
    <span class="k">return</span> <span class="n">token</span><span class="o">.</span><span class="n">decode</span><span class="p">(</span><span class="s1">&#39;unicode_escape&#39;</span><span class="p">)</span></div>


<div class="viewcode-block" id="parse_token"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.parse_token">[docs]</a><span class="k">def</span> <span class="nf">parse_token</span><span class="p">(</span><span class="n">req</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Check if the token is correct</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">token</span> <span class="o">=</span> <span class="n">req</span><span class="o">.</span><span class="n">headers</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;Authorization&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">split</span><span class="p">()[</span><span class="mi">1</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">decode</span><span class="p">(</span><span class="n">token</span><span class="p">,</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;TOKEN_SECRET&#39;</span><span class="p">])</span></div>


<div class="viewcode-block" id="login_required"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.login_required">[docs]</a><span class="k">def</span> <span class="nf">login_required</span><span class="p">(</span><span class="n">f</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Decorator for allowing a logged in user to access to the route</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="nd">@wraps</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
    <span class="k">def</span> <span class="nf">decorated_function</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="c1"># Allow OPTIONS request</span>
        <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">headers</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;Access-Control-Request-Headers&quot;</span><span class="p">)</span> <span class="o">==</span> <span class="s2">&quot;authorization&quot;</span><span class="p">:</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">message</span><span class="o">=</span><span class="s2">&quot;ok&quot;</span><span class="p">)</span>
            <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">=</span> <span class="mi">200</span>
            <span class="k">return</span> <span class="n">response</span>

        <span class="c1"># Reject request with no header Authorization</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">request</span><span class="o">.</span><span class="n">headers</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;Authorization&#39;</span><span class="p">):</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">message</span><span class="o">=</span><span class="s1">&#39;Missing authorization header&#39;</span><span class="p">)</span>
            <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">=</span> <span class="mi">401</span>
            <span class="k">return</span> <span class="n">response</span>

        <span class="k">try</span><span class="p">:</span>
            <span class="n">payload</span> <span class="o">=</span> <span class="n">parse_token</span><span class="p">(</span><span class="n">request</span><span class="p">)</span>
        <span class="k">except</span> <span class="n">DecodeError</span><span class="p">:</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">message</span><span class="o">=</span><span class="s1">&#39;Token is invalid&#39;</span><span class="p">)</span>
            <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">=</span> <span class="mi">401</span>
            <span class="k">return</span> <span class="n">response</span>
        <span class="k">except</span> <span class="n">ExpiredSignature</span><span class="p">:</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">message</span><span class="o">=</span><span class="s1">&#39;Token has expired&#39;</span><span class="p">)</span>
            <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">=</span> <span class="mi">401</span>
            <span class="k">return</span> <span class="n">response</span>

        <span class="n">g</span><span class="o">.</span><span class="n">user_email</span> <span class="o">=</span> <span class="n">payload</span><span class="p">[</span><span class="s1">&#39;sub&#39;</span><span class="p">]</span>

        <span class="k">return</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">decorated_function</span></div>


<div class="viewcode-block" id="login_admin_required"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.login_admin_required">[docs]</a><span class="k">def</span> <span class="nf">login_admin_required</span><span class="p">(</span><span class="n">f</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Decorator for allowing a logged in administrator to access to the route</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="nd">@wraps</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
    <span class="k">def</span> <span class="nf">decorated_function</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="c1"># Allow OPTIONS request</span>
        <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">headers</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;Access-Control-Request-Headers&quot;</span><span class="p">)</span> <span class="o">==</span> <span class="s2">&quot;authorization&quot;</span><span class="p">:</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">message</span><span class="o">=</span><span class="s2">&quot;ok&quot;</span><span class="p">)</span>
            <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">=</span> <span class="mi">200</span>
            <span class="k">return</span> <span class="n">response</span>

        <span class="c1"># Reject request with no header Authorization</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">request</span><span class="o">.</span><span class="n">headers</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;Authorization&#39;</span><span class="p">):</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">message</span><span class="o">=</span><span class="s1">&#39;Missing authorization header&#39;</span><span class="p">)</span>
            <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">=</span> <span class="mi">401</span>
            <span class="k">return</span> <span class="n">response</span>

        <span class="k">try</span><span class="p">:</span>
            <span class="n">payload</span> <span class="o">=</span> <span class="n">parse_token</span><span class="p">(</span><span class="n">request</span><span class="p">)</span>
        <span class="k">except</span> <span class="n">DecodeError</span><span class="p">:</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">message</span><span class="o">=</span><span class="s1">&#39;Token is invalid&#39;</span><span class="p">)</span>
            <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">=</span> <span class="mi">401</span>
            <span class="k">return</span> <span class="n">response</span>
        <span class="k">except</span> <span class="n">ExpiredSignature</span><span class="p">:</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">message</span><span class="o">=</span><span class="s1">&#39;Token has expired&#39;</span><span class="p">)</span>
            <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">=</span> <span class="mi">401</span>
            <span class="k">return</span> <span class="n">response</span>
        <span class="n">g</span><span class="o">.</span><span class="n">user_email</span> <span class="o">=</span> <span class="n">payload</span><span class="p">[</span><span class="s1">&#39;sub&#39;</span><span class="p">]</span>
        <span class="n">user</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">user_manager</span><span class="o">.</span><span class="n">get_user_by_email</span><span class="p">(</span><span class="n">g</span><span class="o">.</span><span class="n">user_email</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">user</span> <span class="ow">and</span> <span class="n">user</span><span class="o">.</span><span class="n">is_admin</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">message</span><span class="o">=</span><span class="s1">&#39;Not admin&#39;</span><span class="p">)</span>
            <span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">=</span> <span class="mi">401</span>
            <span class="k">return</span> <span class="n">response</span>
    <span class="k">return</span> <span class="n">decorated_function</span></div>


<div class="viewcode-block" id="get_user"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.get_user">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/users/&lt;int:id_user&gt;&#39;</span><span class="p">)</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">get_user</span><span class="p">(</span><span class="n">id_user</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get the user in the database</span>
<span class="sd">    :param id_user: int</span>
<span class="sd">    :return: user :{ &quot;name&quot; : str, &quot;surname&quot; : str, &quot;role&quot; : str, &quot;email&quot; : str, &quot;password&quot; : str, &quot;is_admin&quot; : bool }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">user</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">user_manager</span><span class="o">.</span><span class="n">get_user_by_id</span><span class="p">(</span><span class="n">id_user</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">user</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">user</span><span class="p">),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="update_user"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.update_user">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/users/&lt;int:id_user&gt;&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;PUT&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_required</span>
<span class="k">def</span> <span class="nf">update_user</span><span class="p">(</span><span class="n">id_user</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    METHOD : PUT</span>
<span class="sd">    HEADER PARAM  : id_user: int</span>
<span class="sd">    BODY PARAMS : { &quot;name&quot; : str, &quot;surname&quot; : str, &quot;role&quot; : str, &quot;email&quot; : str, &quot;password&quot; : str,&quot;is_admin&quot; : bool }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
    <span class="n">name</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;name&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">surname</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;surname&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">role</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;role&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">email</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;email&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">password</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;password&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">password</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">password</span> <span class="o">=</span> <span class="n">hashpw</span><span class="p">(</span><span class="n">password</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="s1">&#39;utf-8&#39;</span><span class="p">),</span> <span class="n">gensalt</span><span class="p">())</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">password</span><span class="p">)</span>
    <span class="n">is_admin</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;is_admin&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">response</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">user_manager</span><span class="o">.</span><span class="n">update_user</span><span class="p">(</span><span class="n">id_user</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">surname</span><span class="p">,</span> <span class="n">role</span><span class="p">,</span> <span class="n">email</span><span class="p">,</span> <span class="n">password</span><span class="p">,</span> <span class="n">is_admin</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">response</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">response</span><span class="p">:</span>
            <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="mi">200</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">abort</span><span class="p">(</span><span class="mi">400</span><span class="p">)</span></div>


<div class="viewcode-block" id="delete_user"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.delete_user">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/users/&lt;int:id_user&gt;&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;DELETE&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_required</span>
<span class="k">def</span> <span class="nf">delete_user</span><span class="p">(</span><span class="n">id_user</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    METHOD : DELETE</span>
<span class="sd">    HEADER PARAM  : id_user: int</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">user_manager</span><span class="o">.</span><span class="n">delete_user</span><span class="p">(</span><span class="n">id_user</span><span class="p">)</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="get_offers"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.get_offers">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/offers&#39;</span><span class="p">)</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">get_offers</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get all the offers in the database</span>
<span class="sd">    :return: {&quot;offer&quot;:{ &quot;title&quot; : str, &quot;content&quot; : str, &quot;descriptor&quot; : str, &quot;id_user&quot; : int }}</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">db_manager</span><span class="o">.</span><span class="n">offer_manager</span><span class="o">.</span><span class="n">get_all_offers</span><span class="p">()),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="get_offer"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.get_offer">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/offers/&lt;int:id_offer&gt;&#39;</span><span class="p">)</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_required</span>
<span class="k">def</span> <span class="nf">get_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Get the offer of id id_offer</span>
<span class="sd">    :param id_offer: int</span>
<span class="sd">    :return: offer:{ &quot;title&quot; : str, &quot;content&quot; : str, &quot;descriptor&quot; : str, &quot;id_user&quot; : int }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">offer</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">offer_manager</span><span class="o">.</span><span class="n">get_offer_by_id</span><span class="p">(</span><span class="n">id_offer</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">offer</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">offer</span><span class="p">),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="add_offer"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.add_offer">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/offers&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">add_offer</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to add an offer in the database</span>
<span class="sd">    METHOD : POST</span>
<span class="sd">    HEADER PARAM  : None</span>
<span class="sd">    BODY PARAMS : { &quot;title&quot; : str, &quot;content&quot; : str, &quot;descriptor&quot; : str, &quot;id_user&quot; : int }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">offer_manager</span><span class="o">.</span><span class="n">add_offer</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;title&#39;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;content&#39;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;id_user&#39;</span><span class="p">]):</span>
        <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="mi">201</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">400</span><span class="p">)</span></div>


<div class="viewcode-block" id="add_offer_link_field"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.add_offer_link_field">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/offers/link&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_required</span>
<span class="k">def</span> <span class="nf">add_offer_link_field</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to add an offer in the database and link it to a field</span>
<span class="sd">    METHOD : POST</span>
<span class="sd">    HEADER PARAM  : None</span>
<span class="sd">    BODY PARAMS : { &quot;title&quot; : str, &quot;content&quot; : str, &quot;id_user&quot; : int, &quot;dic_fields&quot; : dictionary{id_field, mark}, &quot;inbase&quot; : bool }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">data</span><span class="p">)</span>
    <span class="n">id_offer</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">offer_manager</span><span class="o">.</span><span class="n">add_offer_v2</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;title&#39;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;content&#39;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;id_user&#39;</span><span class="p">])</span>
    <span class="k">for</span> <span class="n">id_field</span><span class="p">,</span> <span class="n">mark</span> <span class="ow">in</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;dic_fields&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
        <span class="n">is_inbase</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">prediction_manager</span><span class="o">.</span><span class="n">add_prediction</span><span class="p">(</span><span class="n">mark</span><span class="p">[</span><span class="s2">&quot;note&quot;</span><span class="p">],</span> <span class="n">mark</span><span class="p">[</span><span class="s2">&quot;id&quot;</span><span class="p">],</span> <span class="n">id_offer</span><span class="p">,</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;inbase&#39;</span><span class="p">])</span>
    <span class="k">if</span> <span class="n">is_inbase</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">is_inbase</span><span class="p">),</span> <span class="mi">201</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">400</span><span class="p">)</span></div>


<div class="viewcode-block" id="update_offer"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.update_offer">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/offers/&lt;int:id_offer&gt;&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;PUT&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_required</span>
<span class="k">def</span> <span class="nf">update_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to update an offer</span>
<span class="sd">    METHOD : PUT</span>
<span class="sd">    HEADER PARAM  : id_offer :int</span>
<span class="sd">    BODY PARAMS : { &quot;title&quot; : str, &quot;content&quot; : str, &quot;descriptor&quot; : str, &quot;id_user&quot; : int }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
    <span class="n">title</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;title&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">content</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;content&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">id_user</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;id_user&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>

    <span class="n">response</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">offer_manager</span><span class="o">.</span><span class="n">update_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">,</span> <span class="n">title</span><span class="p">,</span> <span class="n">content</span><span class="p">,</span> <span class="n">id_user</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">response</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">response</span><span class="p">:</span>
            <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="mi">200</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">abort</span><span class="p">(</span><span class="mi">400</span><span class="p">)</span></div>


<div class="viewcode-block" id="delete_offer"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.delete_offer">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/offers/&lt;int:id_offer&gt;&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;DELETE&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="c1"># @loginRequired</span>
<span class="k">def</span> <span class="nf">delete_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    METHOD : DELETE</span>
<span class="sd">    HEADER PARAM  : id_offer :int</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">offer_manager</span><span class="o">.</span><span class="n">delete_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">)</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="get_fields"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.get_fields">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/fields&#39;</span><span class="p">)</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="c1"># @loginAdminRequired</span>
<span class="k">def</span> <span class="nf">get_fields</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get all the field in the database</span>
<span class="sd">    :return: {&quot;fields&quot;:{&quot;name&quot;: str, &quot;description&quot;: str, &quot;descriptor&quot;: str,&quot;website&quot;: str}}</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="nf">complete_field</span><span class="p">(</span><span class="n">f</span><span class="p">):</span>
        <span class="n">f</span><span class="p">[</span><span class="s1">&#39;contacts&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">get_field_contacts</span><span class="p">(</span><span class="n">f</span><span class="p">[</span><span class="s1">&#39;id&#39;</span><span class="p">])</span>
        <span class="n">f</span><span class="p">[</span><span class="s1">&#39;offers&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">get_field_offers</span><span class="p">(</span><span class="n">f</span><span class="p">[</span><span class="s1">&#39;id&#39;</span><span class="p">])</span>
        <span class="k">return</span> <span class="n">f</span>

    <span class="n">fields</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">get_all_fields</span><span class="p">()</span>
    <span class="k">if</span> <span class="n">fields</span><span class="p">:</span>
        <span class="n">fields</span> <span class="o">=</span> <span class="p">[</span><span class="n">complete_field</span><span class="p">(</span><span class="n">f</span><span class="p">)</span> <span class="k">for</span> <span class="n">f</span> <span class="ow">in</span> <span class="n">fields</span><span class="p">]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">fields</span><span class="p">),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="get_fields_name"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.get_fields_name">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/fields/nameonly&#39;</span><span class="p">)</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="k">def</span> <span class="nf">get_fields_name</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get all the field in the database</span>
<span class="sd">    :return: {&quot;fields&quot;:{&quot;id&quot;:int, &quot;name&quot;: str}}</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">get_all_fields_name</span><span class="p">()),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="get_field"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.get_field">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/fields/&lt;int:id_field&gt;&#39;</span><span class="p">)</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="k">def</span> <span class="nf">get_field</span><span class="p">(</span><span class="n">id_field</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get a field in the database</span>
<span class="sd">    :param id_field: int</span>
<span class="sd">    :return: {&quot;id&quot;: int, &quot;name&quot;: str, &quot;description&quot;: str, &quot;descriptor&quot;: str,&quot;website&quot;: str, &quot;contacts&quot;:}</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">field</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">get_field_by_id</span><span class="p">(</span><span class="n">id_field</span><span class="p">)</span>
    <span class="c1"># print(field)</span>
    <span class="k">if</span> <span class="n">field</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">field</span><span class="p">[</span><span class="s2">&quot;contacts&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">get_field_contacts</span><span class="p">(</span><span class="n">field</span><span class="p">[</span><span class="s1">&#39;id&#39;</span><span class="p">])</span>
        <span class="n">field</span><span class="p">[</span><span class="s1">&#39;offers&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">get_field_offers</span><span class="p">(</span><span class="n">field</span><span class="p">[</span><span class="s1">&#39;id&#39;</span><span class="p">])</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">field</span><span class="p">),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="add_field"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.add_field">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/fields&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">add_field</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to add a field in the database</span>
<span class="sd">    :METHOD : POST</span>
<span class="sd">    :HEADER PARAM  : None</span>
<span class="sd">    :BODY PARAMS :{&quot;name&quot;: str, &quot;description&quot;: str, &quot;descriptor&quot;: str,&quot;website&quot;: str, &quot;contacts&quot;:</span>
<span class="sd">        [{&quot;name&quot;: str, &quot;surname&quot;: str, &quot;email&quot;: str,&quot;phone&quot;: str,&quot;role&quot;: str,&quot;id_field&quot;: int}, ...]</span>
<span class="sd">    }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
    <span class="n">field</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">add_field</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;name&#39;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;description&#39;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;website&#39;</span><span class="p">])</span>
    <span class="k">if</span> <span class="n">field</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">field</span><span class="p">[</span><span class="s1">&#39;contacts&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">contact</span> <span class="ow">in</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;contacts&#39;</span><span class="p">]:</span>
            <span class="n">created_contact</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">contact_manager</span><span class="o">.</span><span class="n">add_contact</span><span class="p">(</span><span class="n">contact</span><span class="p">[</span><span class="s1">&#39;name&#39;</span><span class="p">],</span> <span class="n">contact</span><span class="p">[</span><span class="s1">&#39;surname&#39;</span><span class="p">],</span> <span class="n">contact</span><span class="p">[</span><span class="s1">&#39;email&#39;</span><span class="p">],</span> <span class="n">contact</span><span class="p">[</span><span class="s1">&#39;phone&#39;</span><span class="p">],</span> <span class="n">contact</span><span class="p">[</span><span class="s1">&#39;role&#39;</span><span class="p">],</span> <span class="n">field</span><span class="p">[</span><span class="s1">&#39;id&#39;</span><span class="p">])</span>
            <span class="k">if</span> <span class="n">created_contact</span><span class="p">:</span>
                <span class="n">field</span><span class="p">[</span><span class="s1">&#39;contacts&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">created_contact</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">abort</span><span class="p">(</span><span class="mi">400</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">field</span><span class="p">),</span> <span class="mi">201</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">400</span><span class="p">)</span></div>


<div class="viewcode-block" id="update_field"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.update_field">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/fields/&lt;int:id_field&gt;&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;PUT&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">update_field</span><span class="p">(</span><span class="n">id_field</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to update a field in the database</span>
<span class="sd">    :METHOD : PUT</span>
<span class="sd">    :HEADER PARAM  : id_field : int</span>
<span class="sd">    :BODY PARAMS :{&quot;name&quot;: str, &quot;description&quot;: str, &quot;descriptor&quot;: str,&quot;website&quot;: str}</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
    <span class="n">name</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;name&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">description</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;description&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">website</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;website&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">response</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">update_field</span><span class="p">(</span><span class="n">id_field</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">description</span><span class="p">,</span> <span class="n">website</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">response</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">response</span><span class="p">:</span>
            <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="mi">200</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">abort</span><span class="p">(</span><span class="mi">400</span><span class="p">)</span></div>


<div class="viewcode-block" id="delete_field"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.delete_field">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/fields/&lt;int:id_field&gt;&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;DELETE&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">delete_field</span><span class="p">(</span><span class="n">id_field</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to delete a field in the database</span>
<span class="sd">    :METHOD : DELETE</span>
<span class="sd">    :HEADER PARAM  : id_field : int</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">delete_field</span><span class="p">(</span><span class="n">id_field</span><span class="p">)</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="get_contacts"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.get_contacts">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/contacts&#39;</span><span class="p">)</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">get_contacts</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get all the contact in the database</span>
<span class="sd">    :return: {&quot;contact&quot;:{&quot;name&quot;: str, &quot;surname&quot;: str, &quot;email&quot;: str,&quot;phone&quot;: str,&quot;role&quot;: str,&quot;id_field&quot;: int}}</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">db_manager</span><span class="o">.</span><span class="n">contact_manager</span><span class="o">.</span><span class="n">get_all_contacts</span><span class="p">()),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="get_contact"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.get_contact">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/contacts/&lt;int:id_contact&gt;&#39;</span><span class="p">)</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="k">def</span> <span class="nf">get_contact</span><span class="p">(</span><span class="n">id_contact</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get a contact in the database</span>
<span class="sd">    :param id_contact: int</span>
<span class="sd">    :return: {&quot;name&quot;: str, &quot;surname&quot;: str, &quot;email&quot;: str,&quot;phone&quot;: str,&quot;role&quot;: str,&quot;id_field&quot;: int}</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">contact</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">contact_manager</span><span class="o">.</span><span class="n">get_contact_by_id</span><span class="p">(</span><span class="n">id_contact</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">contact</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">contact</span><span class="p">),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="add_contact"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.add_contact">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/contacts&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">add_contact</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to add a contact in the database</span>
<span class="sd">    :METHOD : POST</span>
<span class="sd">    :HEADER PARAM  : None</span>
<span class="sd">    :BODY PARAMS :{&quot;name&quot;: str, &quot;surname&quot;: str, &quot;email&quot;: str,&quot;phone&quot;: str,&quot;role&quot;: str,&quot;id_field&quot;: int}</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
    <span class="n">email</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;email&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">phone</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;phone&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">role</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;role&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">contact</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">contact_manager</span><span class="o">.</span><span class="n">add_contact</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;name&#39;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;surname&#39;</span><span class="p">],</span> <span class="n">email</span><span class="p">,</span> <span class="n">phone</span><span class="p">,</span> <span class="n">role</span><span class="p">,</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;id_field&#39;</span><span class="p">])</span>
    <span class="k">if</span> <span class="n">contact</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">contact</span><span class="p">),</span> <span class="mi">201</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">400</span><span class="p">)</span></div>


<div class="viewcode-block" id="update_contact"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.update_contact">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/contacts/&lt;int:id_contact&gt;&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;PUT&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">update_contact</span><span class="p">(</span><span class="n">id_contact</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to update a contact in the database</span>
<span class="sd">    :METHOD : PUT</span>
<span class="sd">    :HEADER PARAM  : id_contact : int</span>
<span class="sd">    :BODY PARAMS :{&quot;name&quot;: str, &quot;surname&quot;: str, &quot;email&quot;: str,&quot;phone&quot;: str,&quot;role&quot;: str,&quot;id_field&quot;: int}</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
    <span class="n">name</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;name&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">surname</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;surname&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">email</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;email&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">phone</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;phone&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">role</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;role&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">id_field</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;id_field&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">response</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">contact_manager</span><span class="o">.</span><span class="n">update_contact</span><span class="p">(</span><span class="n">id_contact</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">surname</span><span class="p">,</span> <span class="n">email</span><span class="p">,</span> <span class="n">phone</span><span class="p">,</span> <span class="n">role</span><span class="p">,</span> <span class="n">id_field</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">response</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">response</span><span class="p">:</span>
            <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="mi">200</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">abort</span><span class="p">(</span><span class="mi">400</span><span class="p">)</span></div>


<div class="viewcode-block" id="delete_contact"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.delete_contact">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/contacts/&lt;int:id_contact&gt;&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;DELETE&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">delete_contact</span><span class="p">(</span><span class="n">id_contact</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to delete a contact in the database</span>
<span class="sd">    :METHOD : DELETE</span>
<span class="sd">    :HEADER PARAM  : id_contact : int</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">if</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">contact_manager</span><span class="o">.</span><span class="n">delete_contact</span><span class="p">(</span><span class="n">id_contact</span><span class="p">)</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="generate_prediction"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.generate_prediction">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/generatePrediction&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="k">def</span> <span class="nf">generate_prediction</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get a prediction from an offer</span>
<span class="sd">    METHOD : POST</span>
<span class="sd">    HEADER PARAM  : None</span>
<span class="sd">    BODY PARAMS : { &quot;title&quot; : str, &quot;content&quot; : str }</span>
<span class="sd">    RETURNS :</span>
<span class="sd">        {</span>
<span class="sd">            &quot;field&quot;: { &quot;name&quot;: str, &quot;description&quot;: str, &quot;descriptor&quot;: str, &quot;website&quot;: str }</span>
<span class="sd">        }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">with</span> <span class="n">graph</span><span class="o">.</span><span class="n">as_default</span><span class="p">():</span>
        <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;-------------------------------------JSON data ----------------------------------------&quot;</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;content&#39;</span><span class="p">])</span>

        <span class="n">predictions</span> <span class="o">=</span> <span class="n">model</span><span class="o">.</span><span class="n">predict</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;content&#39;</span><span class="p">])</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">predictions</span><span class="p">)</span>
        <span class="n">res</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">prediction</span><span class="p">,</span> <span class="n">note</span> <span class="ow">in</span> <span class="n">predictions</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="n">field</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">get_field_by_id</span><span class="p">(</span><span class="n">prediction</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">field</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">field</span><span class="p">[</span><span class="s2">&quot;note&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">note</span> <span class="o">*</span> <span class="mi">100</span><span class="p">)</span>
                <span class="n">res</span><span class="p">[</span><span class="n">prediction</span><span class="p">]</span> <span class="o">=</span> <span class="n">field</span>

        <span class="k">if</span> <span class="kc">None</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">jsonify</span><span class="p">(</span><span class="n">res</span><span class="p">))</span>
            <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">res</span><span class="p">),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="offers_by_user"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.offers_by_user">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/searchOffersByUser/&lt;int:id_user&gt;&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;GET&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="k">def</span> <span class="nf">offers_by_user</span><span class="p">(</span><span class="n">id_user</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get all the offers who correspond to an user</span>
<span class="sd">    :METHOD : GET</span>
<span class="sd">    :HEADER PARAM  : id_user : int</span>
<span class="sd">    :BODY PARAMS : none</span>
<span class="sd">    :return: {&quot;offer&quot;:{ &quot;title&quot; : str, &quot;content&quot; : str, &quot;descriptor&quot; : str, &quot;id_user&quot; : int }}</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">offers</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">offer_manager</span><span class="o">.</span><span class="n">offers_by_user</span><span class="p">(</span><span class="n">id_user</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">offers</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">offers</span><span class="p">),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="fields_by_offer"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.fields_by_offer">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/searchFieldsByOffer/&lt;int:id_offer&gt;&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;GET&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_required</span>
<span class="k">def</span> <span class="nf">fields_by_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get all the field who correspond to an offer</span>
<span class="sd">    :METHOD : GET</span>
<span class="sd">    :HEADER PARAM  : id_offer : int</span>
<span class="sd">    :BODY PARAMS : none</span>
<span class="sd">    :return: {&quot;fields&quot;:{&quot;id&quot;: int,&quot;name&quot;: str,&quot;inbase&quot;: boolean}}</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">res</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="n">dic</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">prediction_manager</span><span class="o">.</span><span class="n">fields_by_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">d</span> <span class="ow">in</span> <span class="n">dic</span><span class="p">:</span>
        <span class="c1"># d[0] = id_field | d[1] = mark</span>
        <span class="n">field</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">field_manager</span><span class="o">.</span><span class="n">get_field_by_id</span><span class="p">(</span><span class="n">d</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
        <span class="k">if</span> <span class="n">field</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">field</span><span class="p">[</span><span class="s2">&quot;note&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">d</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">res</span><span class="p">[</span><span class="n">d</span><span class="p">[</span><span class="mi">0</span><span class="p">]]</span> <span class="o">=</span> <span class="n">field</span>

    <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">res</span><span class="p">),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="nb_prediction"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.nb_prediction">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/nbPrediction&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">nb_prediction</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get the number of prediction between two date</span>
<span class="sd">    :METHOD : GET</span>
<span class="sd">    :HEADER PARAM  : none</span>
<span class="sd">    :BODY PARAMS : {&quot;begin_date&quot;: date,&quot;end_date&quot;:date}</span>
<span class="sd">    :return: int</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
    <span class="n">begin_date</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;begin_date&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">end_date</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;end_date&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">begin_date</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">strptime</span><span class="p">(</span><span class="n">begin_date</span><span class="p">,</span> <span class="s2">&quot;%Y-%m-</span><span class="si">%d</span><span class="s2">&quot;</span><span class="p">)</span><span class="o">.</span><span class="n">date</span><span class="p">()</span>
    <span class="n">end_date</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">strptime</span><span class="p">(</span><span class="n">end_date</span><span class="p">,</span> <span class="s2">&quot;%Y-%m-</span><span class="si">%d</span><span class="s2">&quot;</span><span class="p">)</span><span class="o">.</span><span class="n">date</span><span class="p">()</span>
    <span class="n">number</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">prediction_manager</span><span class="o">.</span><span class="n">nb_prediction</span><span class="p">(</span><span class="n">begin_date</span><span class="p">,</span> <span class="n">end_date</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">number</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">number</span><span class="p">),</span> <span class="mi">200</span></div>


<div class="viewcode-block" id="get_accuracy"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.get_accuracy">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/accuracy&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;GET&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_admin_required</span>
<span class="k">def</span> <span class="nf">get_accuracy</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get the accuracy of the system</span>
<span class="sd">    :METHOD : GET</span>
<span class="sd">    :HEADER PARAM  : None</span>
<span class="sd">    :BODY PARAMS : None</span>
<span class="sd">    :return: int</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">nb_test</span><span class="p">,</span> <span class="n">accuracy</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span>

    <span class="k">if</span> <span class="n">nb_test</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span> <span class="n">accuracy</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">404</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">nb_test</span><span class="p">,</span> <span class="n">accuracy</span><span class="p">),</span> <span class="mi">200</span></div>


<span class="c1"># AUTHETIFICATION</span>
<div class="viewcode-block" id="update_prediction_by_id_offer"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.update_prediction_by_id_offer">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/update_prediction_by_id_offer&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_required</span>
<span class="k">def</span> <span class="nf">update_prediction_by_id_offer</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to update the prediction corresponding to an offer</span>
<span class="sd">    :METHOD : POST</span>
<span class="sd">    :HEADER PARAM  : none</span>
<span class="sd">    :BODY PARAMS : { &quot;id_offer&quot; : int, &quot;id_field&quot; : int }</span>
<span class="sd">    :return: int</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
    <span class="n">in_base</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;in_base&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="n">id_field</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;id_field&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">prediction_manager</span><span class="o">.</span><span class="n">update_prediction_by_id_offer</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;id_offer&#39;</span><span class="p">],</span> <span class="n">id_field</span><span class="p">,</span> <span class="n">in_base</span><span class="p">):</span>
        <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="mi">201</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">400</span><span class="p">)</span></div>


<span class="c1"># AUTHENTIFICATION</span>
<div class="viewcode-block" id="signup"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.signup">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/auth/signup&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="k">def</span> <span class="nf">signup</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    METHOD : POST</span>
<span class="sd">    HEADER PARAM  : None</span>
<span class="sd">    BODY PARAMS : { &quot;name&quot; : str, &quot;surname&quot; : str, &quot;role&quot; : str, &quot;email&quot; : str, &quot;password&quot; : str }</span>
<span class="sd">    RETURNS :</span>
<span class="sd">        {</span>
<span class="sd">            &quot;token&quot;: str,</span>
<span class="sd">            &quot;user&quot;: { &quot;email&quot;: str, &quot;id&quot;: int, &quot;is_admin&quot;: boolean, &quot;name&quot;: str,</span>
<span class="sd">                        &quot;password&quot;: str, &quot;role&quot;: str, &quot;surname&quot;: str }</span>
<span class="sd">        }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>

    <span class="n">user</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">user_manager</span><span class="o">.</span><span class="n">get_user_by_email</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s2">&quot;email&quot;</span><span class="p">])</span>

    <span class="k">if</span> <span class="n">user</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">error</span><span class="o">=</span><span class="s2">&quot;User already exist&quot;</span><span class="p">),</span> <span class="mi">404</span>

    <span class="n">password</span> <span class="o">=</span> <span class="n">hashpw</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s2">&quot;password&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="s1">&#39;utf-8&#39;</span><span class="p">),</span> <span class="n">gensalt</span><span class="p">())</span>

    <span class="k">if</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">user_manager</span><span class="o">.</span><span class="n">add_user</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s2">&quot;name&quot;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s2">&quot;surname&quot;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s2">&quot;role&quot;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;email&#39;</span><span class="p">],</span> <span class="n">password</span><span class="p">,</span> <span class="kc">False</span><span class="p">):</span>
        <span class="n">session</span><span class="p">[</span><span class="s1">&#39;logged_in&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="kc">True</span>
        <span class="n">user</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">user_manager</span><span class="o">.</span><span class="n">get_user_by_email</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s2">&quot;email&quot;</span><span class="p">])</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">user</span><span class="o">=</span><span class="n">user</span><span class="o">.</span><span class="n">serialize</span><span class="p">(),</span> <span class="n">token</span><span class="o">=</span><span class="n">create_token</span><span class="p">(</span><span class="n">user</span><span class="p">)),</span> <span class="mi">200</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">abort</span><span class="p">(</span><span class="mi">400</span><span class="p">)</span></div>


<div class="viewcode-block" id="login"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.login">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/auth/login&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="k">def</span> <span class="nf">login</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    METHOD : POST</span>
<span class="sd">    HEADER PARAM  : None</span>
<span class="sd">    BODY PARAMS : { &quot;emailUser&quot; : str, &quot;password&quot; : str}</span>
<span class="sd">    RETURNS :</span>
<span class="sd">        {</span>
<span class="sd">            &quot;token&quot;: str,</span>
<span class="sd">            &quot;user&quot;: { &quot;email&quot;: str, &quot;id&quot;: int, &quot;is_admin&quot;: boolean, &quot;name&quot;: str,</span>
<span class="sd">                        &quot;password&quot;: str, &quot;role&quot;: str, &quot;surname&quot;: str }</span>
<span class="sd">        }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>

    <span class="n">user</span> <span class="o">=</span> <span class="n">db_manager</span><span class="o">.</span><span class="n">user_manager</span><span class="o">.</span><span class="n">get_user_by_email</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s2">&quot;emailUser&quot;</span><span class="p">])</span>

    <span class="k">if</span> <span class="ow">not</span> <span class="n">user</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">error</span><span class="o">=</span><span class="s2">&quot;No such user&quot;</span><span class="p">),</span> <span class="mi">404</span>

    <span class="n">password</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="s2">&quot;password&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="s1">&#39;utf-8&#39;</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">user</span><span class="o">.</span><span class="n">password</span> <span class="o">==</span> <span class="n">hashpw</span><span class="p">(</span><span class="n">password</span><span class="p">,</span> <span class="n">user</span><span class="o">.</span><span class="n">password</span><span class="p">):</span>
        <span class="n">session</span><span class="p">[</span><span class="s1">&#39;logged_in&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="kc">True</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">user</span><span class="o">=</span><span class="n">user</span><span class="o">.</span><span class="n">serialize</span><span class="p">(),</span> <span class="n">token</span><span class="o">=</span><span class="n">create_token</span><span class="p">(</span><span class="n">user</span><span class="p">)),</span> <span class="mi">200</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">jsonify</span><span class="p">(</span><span class="n">error</span><span class="o">=</span><span class="s2">&quot;Wrong name or password&quot;</span><span class="p">),</span> <span class="mi">400</span></div>


<div class="viewcode-block" id="logout"><a class="viewcode-back" href="../../../backend_doc/api.html#SmartRecruiting_BackEnd.api.routes.logout">[docs]</a><span class="nd">@app</span><span class="o">.</span><span class="n">route</span><span class="p">(</span><span class="s1">&#39;/auth/logout&#39;</span><span class="p">,</span> <span class="n">methods</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;POST&#39;</span><span class="p">])</span>
<span class="nd">@cross_origin</span><span class="p">()</span>
<span class="nd">@login_required</span>
<span class="k">def</span> <span class="nf">logout</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    METHOD : POST</span>
<span class="sd">    HEADER PARAM  : {Authorization : Bearer token}</span>
<span class="sd">    BODY PARAMS : None</span>
<span class="sd">    RETURNS : { &#39;result&#39;: &#39;success&#39; }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">session</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="s1">&#39;logged_in&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">jsonify</span><span class="p">({</span><span class="s1">&#39;result&#39;</span><span class="p">:</span> <span class="s1">&#39;success&#39;</span><span class="p">}),</span> <span class="mi">200</span></div>
</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, Projet 21

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>